# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`weston`](#weston): Install the weston desktop
* [`weston::vnc_server`](#weston--vnc_server): Setup weston VNC sessions

## Classes

### <a name="weston"></a>`weston`

Simply install the weston desktop

#### Examples

##### 

```puppet
include weston
```

#### Parameters

The following parameters are available in the `weston` class:

* [`manage_packages`](#-weston--manage_packages)
* [`package_names`](#-weston--package_names)
* [`packages_ensure`](#-weston--packages_ensure)
* [`manage_weston_ini`](#-weston--manage_weston_ini)
* [`weston_ini_path`](#-weston--weston_ini_path)
* [`weston_ini_owner`](#-weston--weston_ini_owner)
* [`weston_ini_group`](#-weston--weston_ini_group)
* [`weston_ini_mode`](#-weston--weston_ini_mode)
* [`weston_ini_settings`](#-weston--weston_ini_settings)

##### <a name="-weston--manage_packages"></a>`manage_packages`

Data type: `Boolean`

Should this module even care about the packages?

Default value: `true`

##### <a name="-weston--package_names"></a>`package_names`

Data type: `Array[String[1]]`

Packages to install

Default value: `['weston']`

##### <a name="-weston--packages_ensure"></a>`packages_ensure`

Data type: `Stdlib::Ensure::Package`

What to ensure for the packages

Default value: `'present'`

##### <a name="-weston--manage_weston_ini"></a>`manage_weston_ini`

Data type: `Boolean`

Should we write out a global weston config?

Default value: `false`

##### <a name="-weston--weston_ini_path"></a>`weston_ini_path`

Data type: `Stdlib::Absolutepath`

Where is the global weston.ini

Default value: `'/etc/xdg/weston/weston.ini'`

##### <a name="-weston--weston_ini_owner"></a>`weston_ini_owner`

Data type: `String`

Probably root

Default value: `'root'`

##### <a name="-weston--weston_ini_group"></a>`weston_ini_group`

Data type: `String`

Probably root

Default value: `'root'`

##### <a name="-weston--weston_ini_mode"></a>`weston_ini_mode`

Data type: `String`

This should be world readable

Default value: `'0644'`

##### <a name="-weston--weston_ini_settings"></a>`weston_ini_settings`

Data type: `Hash`

A hash of the settings you want.
weston::weston_ini_settings:
  shell:
    'clock-format': 'seconds-24h'

Default value: `{}`

### <a name="weston--vnc_server"></a>`weston::vnc_server`

Setup weston VNC sessions

#### Parameters

The following parameters are available in the `weston::vnc_server` class:

* [`manage_vnc_start_script`](#-weston--vnc_server--manage_vnc_start_script)
* [`manage_vnc_options_file`](#-weston--vnc_server--manage_vnc_options_file)
* [`manage_vnc_users_file`](#-weston--vnc_server--manage_vnc_users_file)
* [`manage_vnc_polkit_file`](#-weston--vnc_server--manage_vnc_polkit_file)
* [`vnc_start_script`](#-weston--vnc_server--vnc_start_script)
* [`vnc_options_file`](#-weston--vnc_server--vnc_options_file)
* [`vnc_server_options`](#-weston--vnc_server--vnc_server_options)
* [`vnc_users_file`](#-weston--vnc_server--vnc_users_file)
* [`vnc_start_script_mode`](#-weston--vnc_server--vnc_start_script_mode)
* [`vnc_options_file_mode`](#-weston--vnc_server--vnc_options_file_mode)
* [`vnc_users_file_mode`](#-weston--vnc_server--vnc_users_file_mode)
* [`manage_vnc_services`](#-weston--vnc_server--manage_vnc_services)
* [`default_vnc_service_ensure`](#-weston--vnc_server--default_vnc_service_ensure)
* [`default_vnc_service_enable`](#-weston--vnc_server--default_vnc_service_enable)
* [`manage_systemd_unit_file`](#-weston--vnc_server--manage_systemd_unit_file)
* [`systemd_template_startswith`](#-weston--vnc_server--systemd_template_startswith)
* [`systemd_template_endswith`](#-weston--vnc_server--systemd_template_endswith)
* [`vnc_polkit_file`](#-weston--vnc_server--vnc_polkit_file)
* [`vnc_polkit_file_mode`](#-weston--vnc_server--vnc_polkit_file_mode)
* [`default_user_can_control_service`](#-weston--vnc_server--default_user_can_control_service)
* [`default_extra_users_can_control_service`](#-weston--vnc_server--default_extra_users_can_control_service)
* [`vnc_sessions`](#-weston--vnc_server--vnc_sessions)

##### <a name="-weston--vnc_server--manage_vnc_start_script"></a>`manage_vnc_start_script`

Data type: `Boolean`

Do we manage the start script?

Default value: `true`

##### <a name="-weston--vnc_server--manage_vnc_options_file"></a>`manage_vnc_options_file`

Data type: `Boolean`

Do we manage the vnc options file?

Default value: `true`

##### <a name="-weston--vnc_server--manage_vnc_users_file"></a>`manage_vnc_users_file`

Data type: `Boolean`

Do we manage the vnc users file?

Default value: `true`

##### <a name="-weston--vnc_server--manage_vnc_polkit_file"></a>`manage_vnc_polkit_file`

Data type: `Boolean`

Do we manage the vnc polkit file?

Default value: `true`

##### <a name="-weston--vnc_server--vnc_start_script"></a>`vnc_start_script`

Data type: `Stdlib::Absolutepath`

The script that starts weston in VNC mode

Default value: `'/usr/libexec/weston-vnc'`

##### <a name="-weston--vnc_server--vnc_options_file"></a>`vnc_options_file`

Data type: `Stdlib::Absolutepath`

An environment file you can use to inject options

Default value: `'/etc/xdg/weston/vncserver.opts'`

##### <a name="-weston--vnc_server--vnc_server_options"></a>`vnc_server_options`

Data type: `Array[String[1]]`

Extra options to set on the VNC server (ie ['--address=::1', '--disable-transport-layer-security'])

Default value: `[]`

##### <a name="-weston--vnc_server--vnc_users_file"></a>`vnc_users_file`

Data type: `Stdlib::Absolutepath`

A list of which users are using which VNC ports

Default value: `'/etc/xdg/weston/vncserver.users'`

##### <a name="-weston--vnc_server--vnc_start_script_mode"></a>`vnc_start_script_mode`

Data type: `String`

This should have world exec as it runs as your VNC user

Default value: `'0755'`

##### <a name="-weston--vnc_server--vnc_options_file_mode"></a>`vnc_options_file_mode`

Data type: `String`

This should have world read so your VNC user can look at it

Default value: `'0644'`

##### <a name="-weston--vnc_server--vnc_users_file_mode"></a>`vnc_users_file_mode`

Data type: `String`

This should have world read so your VNC user can look at it

Default value: `'0644'`

##### <a name="-weston--vnc_server--manage_vnc_services"></a>`manage_vnc_services`

Data type: `Boolean`

Should this module manage the VNC server services

Default value: `true`

##### <a name="-weston--vnc_server--default_vnc_service_ensure"></a>`default_vnc_service_ensure`

Data type: `Optional[Enum['running', 'stopped']]`

What should the VNC service ensure be by default?
NULL works for "no preference"

Default value: `undef`

##### <a name="-weston--vnc_server--default_vnc_service_enable"></a>`default_vnc_service_enable`

Data type: `Optional[Boolean]`

What should the VNC service enable be by default?
NULL works for "no preference"

Default value: `undef`

##### <a name="-weston--vnc_server--manage_systemd_unit_file"></a>`manage_systemd_unit_file`

Data type: `Boolean`

Should this module setup the systemd template unit

Default value: `true`

##### <a name="-weston--vnc_server--systemd_template_startswith"></a>`systemd_template_startswith`

Data type: `String`

What is the 'unit name' of the service

Default value: `'weston-vncserver'`

##### <a name="-weston--vnc_server--systemd_template_endswith"></a>`systemd_template_endswith`

Data type: `String`

This should always be `.service` unless you're up to something weird

Default value: `'.service'`

##### <a name="-weston--vnc_server--vnc_polkit_file"></a>`vnc_polkit_file`

Data type: `Stdlib::Absolutepath`

A policy kit file you can use to let users restart their own sessions via systemctl --system

Default value: `'/etc/polkit-1/rules.d/25-puppet-weston-vnc_server.rules'`

##### <a name="-weston--vnc_server--vnc_polkit_file_mode"></a>`vnc_polkit_file_mode`

Data type: `String`

This should have world read so unpriviledged polkit can check it

Default value: `'0644'`

##### <a name="-weston--vnc_server--default_user_can_control_service"></a>`default_user_can_control_service`

Data type: `Boolean`

Should this module configure polkit so the VNC user can control the system service by default?

Default value: `false`

##### <a name="-weston--vnc_server--default_extra_users_can_control_service"></a>`default_extra_users_can_control_service`

Data type: `Array[String[1]]`

Extra users who will automatically be granted polkit rights to the system service by default

Default value: `[]`

##### <a name="-weston--vnc_server--vnc_sessions"></a>`vnc_sessions`

Data type: `Hash[String, Hash[Enum['displaynumber', 'user_can_control_service', 'comment', 'ensure', 'enable', 'extra_users_can_control_service'], Variant[Array[String], String, Integer, Boolean, Undef]]]`

A hash of VNC servers to setup  Format:
weston::vnc_server::vnc_sessions:
  userA:
    comment: Sometimes you've gotta write it down
    displaynumber: 1
    ensure: running
    enable: true
    user_can_control_service: true
    extra_users_can_control_service:
      - userB
  userB:
    displaynumber: 5902
    ensure: NULL
    enable: false
    user_can_control_service: false

Default value: `{}`

